#text_reverser
# Python script to import a text file, convert it to a list, reverse the text
# form a continuous string and write out a new file.
#
# LAST UPDATED by Dr Andrew French March 2018

#import time and gui libraries
import time
import tkinter as tk
from tkinter import filedialog

#Display greeting message
print(" A Python text reverser programme")

#Display's today's date and time
t = time.strftime('%X %x %Z')
print(" The current time and date is " + t + "\n")

#Prompt user for file. Do this by creating a GUI window, and then obscuring it
root = tk.Tk()
root.withdraw()
file_paths = filedialog.askopenfilenames(filetypes=[("Text files","*.txt")])

#Store time since current epoch (1970?) in s, and hence start an internal stopwatch.
t0 = time.time()
t1 = t0

#Step through files and decrypt or encrypt
for i in range(0,len(file_paths)):
    f = file_paths[i]
    readfile = open(f, "r")
    writefile = open(f.replace(".txt","_reverse.txt"), "w")

    #Create list from file content (a string)
    s = list(readfile.read())

    #Reverse the order of string s
    s = list(reversed(s))
    #s = s[::-1]
    
    #Write updated file and close
    writefile.write(''.join(s))
    writefile.close()
        
    #Display completion message to console
    print("\n File : " + file_paths[i] )
    tt = time.time()
    print(" Reversal complete in " + str( tt - t1) + " seconds.")

    #Update split time
    t1 = tt

#Wait for user input to close terminal window
print("\n Total processing time is: " + str(time.time() - t0) + " seconds.")
input("\n Press return to close ")

#End of code
