#gen_cipherkey
# Python script which generates a substitution cipher key based upon
# a random permutation of an English alphabet, including some other ASCII
# characters too! Output is a text file with first line being the alphabet
# and second line being the cipherbet.
#
# LAST UPDATED by Andy French Jan 2018

import time
import numpy as Npy

#Define alphabet
alphabet = list("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ")
alphabet = alphabet + list("0123456789@!£$%*?/\<>,.+-=][{}~#")
alphabet = alphabet + [" "] + ["\n"]

#Display message to console
print("\n Python random substitution cipher key generator")
print(" By Dr Andrew French Jan 2018 "  )
print("\n Alphabet is: \n" + "".join(alphabet))

#Randomly shuffle alphabet to form cipherbet
indices = Npy.arange( len(alphabet) )
Npy.random.shuffle(indices)
cipherbet = alphabet[:]
for i in range( 0,len(alphabet) ):
    cipherbet[i] = alphabet[ indices[i] ]
print("\n Cipherbet is: \n" + "".join(cipherbet) + "\n")

#Get current date and time and hence construct filename
t = time.strftime('%X %x %Z')
t = t.replace(":","")
t = t.replace("/","")
t = t.replace(" ","")
t = t[0:11]

#Write alphabet and cipherbet to file
filename = "cipherkey " + t + ".txt"
f = open(filename , "w")
f.write( "".join( alphabet + cipherbet ) )
f.close()
print("\n " + filename + " saved.")

#Wait for user input to close terminal window    
input("\n Press return to close ")

#End of code
