#gen_polycipherkey
# Python script which generates a set of random cipher keys, to be used with a
# polyalphabetic cipher.
#
# LAST UPDATED by Andy French Jan 2018

import time
import numpy as Npy

#Display message to console
print("\n Python random polyalphabetic cipher key generator")
print(" By Dr Andrew French Jan 2018 "  )

#Ask user for number of alphabets
N = int( input( "\n Define number of alphabets (max 999) : " ) )

#Define alphabet
alphabet = list("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ")
alphabet = alphabet + list("0123456789@!£$%^*()?/\<>,.+-=][{}~#")

#Add spaces and line returns
alphabet = alphabet + [" "] + ["\n"]

#Randomly shuffle alphabet to form cipherbet
cipherbet=[]
for j in range(0,N):
  indices = Npy.arange( len(alphabet) )
  Npy.random.shuffle(indices)
  c = alphabet[:]
  for i in range( 0,len(alphabet) ):
    c[i] = alphabet[ indices[i] ]
  cipherbet = cipherbet + c

#Get current date and time and hence construct filename
t = time.strftime('%X %x %Z')
t = t.replace(":","")
t = t.replace("/","")
t = t.replace(" ","")
t = t[0:11]

#Write alphabet and cipherbet to file
filename = "polycipherkey " + str(N).zfill(3) + t + ".txt"
f = open(filename , "w")
f.write( str(N).zfill(3) + "".join( alphabet + cipherbet ) )
f.close()
print("\n " + filename + " saved.")

#Wait for user input to close terminal window    
input("\n Press return to close ")

#End of code
