#gen_vigenerecipherkey
# Python script which generates a substitution cipher key based upon
# succesive Caesar shifts of the standard English alphabet defined
# by a code word. Note codeword is limited to 999 characters.
#
# LAST UPDATED by Andy French Jan 2018

#Display message to console
print("\n Python Vigenere cipher key generator")
print(" By Dr Andrew French Jan 2018 "  )

#Ask user for Vigenere code word
codeword = input( "\n State Vigenere code word : " ) 
codeword = list( codeword.lower() )

#Define standard lower and upper case alphabet
alphabet = "abcdefghijklmnopqrstuvwxyz"
N = len(alphabet)
alphabet_upper = list( alphabet.upper() )
alphabet = list(alphabet) + alphabet_upper

#Determine Caesar shifted alphabets with first letter being the letters in the codeword
cipherbet = []
for i in range( 0,len(codeword) ):

    #Find index of lower case alphabet that corresponds to starting letter of cipherbet
    index = alphabet.index( codeword[i] )

    #App to cipherbet, including upper case version as well
    cipherbet = cipherbet + alphabet[index:N] + alphabet[0:index] + alphabet_upper[index:N] + alphabet_upper[0:index]

#Write alphabet and cipherbet to file. The first three characters
#will define the length of the codeword and hence the number of cipherbets
filename = "vigenere cipherkey " + "".join(codeword) + ".txt"
f = open(filename , "w")
f.write( str(len(codeword)).zfill(3) + "".join( alphabet + cipherbet ) )
f.close()
print("\n " + filename + " saved.")

#Wait for user input to close terminal window    
input("\n Press return to close ")

#End of code
