#rsa_decrypt_message
# Uses RSA private key to decrypt message encrypted using the public key
# associated with the private key.
#
# LAST UPDATED by Andy French Feb 2018

#Import primesieve and GUI libraries
import tkinter as tk
from tkinter import filedialog
import numpy as np

#Display greeting message
print(" RSA decryption")
print(" By Dr Andrew French. February 2018")

# 

#Request and import private key from a text file
root = tk.Tk()
root.withdraw()
file_path = filedialog.askopenfilename(title = "Choose private key file...",
filetypes=[("Text files","*.txt")])
print( '\n Importing RSA private key file ...')
privatekeyfile = open( file_path, "r" )
s = privatekeyfile.read().split('\n')
k = [ int(i) for i in s ]
privatekeyfile.close()

#Step through integer array k and extract key integers p,q,e,d,N
p = k[0]
q = k[1]
e = k[2]
d = k[3]
N = p*q

#Print Alice's numbers
print( '\n Alice has numbers: \n p = ' + str(p) + '\n q = ' + str(q) +
'\n N = ' + str(N) + '\n e = ' + str(e) + '\n d = ' + str(d) )

#Open Bob's file sent to Alice and return a list of characters
print( '\n Opening encrypted text file ...')
root = tk.Tk()
root.withdraw()
file_path = filedialog.askopenfilename(title = "Choose private key file...",
filetypes=[("Text files","*.txt")])
encrypt = open( file_path, "r" )
s = encrypt.read().split(',')
encrypt.close()

#Step through file and extract integers. Use the pow function
#to determine the ASCII code and then convert these to strings
print( '\n Decrypting text file ...')
S = [ chr( pow( int(i), d, N ) ) for i in s ]

#Write out decrypted file and close it
decrypt = open( file_path.replace(".txt","_decrypt.txt"), "w" )
decrypt.write( ''.join(S) )
decrypt.close()
    
#Wait for user input to close terminal window
print( '\n RSA decryption complete. ')
input("\n Press return to close ")

#End of code
