#rsa_encrypt_message
# Uses a public key to perform RSA encryption of a text file.
#
# LAST UPDATED by Andy French Feb 2018

#Import primesieve and GUI libraries
import tkinter as tk
from tkinter import filedialog
import numpy as np

#Display greeting message
print(" RSA public key encryption")
print(" By Dr Andrew French. February 2018")

# 

#Request and import public key from a text file
root = tk.Tk()
root.withdraw()
file_path = filedialog.askopenfilename(title = "Choose public key file...",
filetypes=[("Text files","*.txt")])
print( '\n Importing RSA public key file ...')
publickeyfile = open( file_path, "r" )
s = publickeyfile.read().split('\n')
k = [ int(i) for i in s ]
publickeyfile.close()

#Step through integer array k and extract key integers N and e
N = k[0]
e = k[1]

#Display public key details
print( '\n Public key: \n N = ' + str(N) + '\n e = ' + str(e) )

#Load Bob's text file(s) Do this by creating a GUI window, and then obscuring it
root = tk.Tk()
root.withdraw()
file_path = filedialog.askopenfilename(title = "Choose text file to encrypt...",
filetypes=[("Text files","*.txt")])
print( '\n Loading Bob\'s text file ...')
plaintext = open( file_path, "r" )

#Step through Bob's plaintext and use N,e to encrypt the ASCII codes of the
#characters to a list of integers. Then use p,q,e,d to simulate Alice's decryption
#of the encrypted message sent to Alice by Bob

#Create list from file content (a string)    
s = list( plaintext.read() )
plaintext.close()

#Step through s and encrypt. Note pow(a,b,c) evaluates a**b % c efficiently
print( '\n Encrypting Bob\'s text using N and e from Alice ...')
m = ['']*len(s)
for n in range(0,len(s)):
    m[n] = str( pow( ord( s[n] ), e, N ) )
  
#Write encrypted text file, consisting of , separated integers
print( '\n Writing encrypted text file ...')
encrypt = open( file_path.replace(".txt","_encrypt.txt"), "w" )
encrypt.write(','.join(m) )
encrypt.close()
    
#Wait for user input to close terminal window
print( '\n RSA encryption complete. ')
input("\n Press return to close ")

#End of code
